"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var modelMerger_1 = require("./modelMerger");
var SamplingStrategy;
(function (SamplingStrategy) {
    SamplingStrategy["One"] = "One";
    SamplingStrategy["All"] = "All";
    SamplingStrategy["Random"] = "Random";
})(SamplingStrategy = exports.SamplingStrategy || (exports.SamplingStrategy = {}));
var randomSamplingLimit = 50;
// Maybe we need a new type here in the future. 
var DocumentConnector = /** @class */ (function () {
    function DocumentConnector(samplingStrategy) {
        this.samplingStrategy = samplingStrategy;
    }
    DocumentConnector.prototype.sample = function (collection) {
        switch (this.samplingStrategy) {
            case SamplingStrategy.One: return this.sampleOne(collection);
            case SamplingStrategy.All: return this.sampleAll(collection);
            case SamplingStrategy.Random: return this.sampleMany(collection, randomSamplingLimit);
        }
        throw new Error('Invalid sampling type specified: ' + this.samplingStrategy);
    };
    DocumentConnector.prototype.listModels = function (schemaName) {
        return __awaiter(this, void 0, void 0, function () {
            var e_1, _a, types, collections, collections_1, collections_1_1, _b, name_1, collection, merger, iterator, item, mergeResult, e_1_1;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        types = [];
                        return [4 /*yield*/, this.getInternalCollections(schemaName)];
                    case 1:
                        collections = _c.sent();
                        _c.label = 2;
                    case 2:
                        _c.trys.push([2, 11, 12, 13]);
                        collections_1 = __values(collections), collections_1_1 = collections_1.next();
                        _c.label = 3;
                    case 3:
                        if (!!collections_1_1.done) return [3 /*break*/, 10];
                        _b = collections_1_1.value, name_1 = _b.name, collection = _b.collection;
                        merger = new modelMerger_1.ModelMerger(name_1, false);
                        return [4 /*yield*/, this.sample(collection)];
                    case 4:
                        iterator = _c.sent();
                        _c.label = 5;
                    case 5: return [4 /*yield*/, iterator.hasNext()];
                    case 6:
                        if (!_c.sent()) return [3 /*break*/, 8];
                        return [4 /*yield*/, iterator.next()];
                    case 7:
                        item = _c.sent();
                        merger.analyze(item);
                        return [3 /*break*/, 5];
                    case 8:
                        mergeResult = merger.getType();
                        types.push.apply(types, __spread([mergeResult.type], mergeResult.embedded));
                        _c.label = 9;
                    case 9:
                        collections_1_1 = collections_1.next();
                        return [3 /*break*/, 3];
                    case 10: return [3 /*break*/, 13];
                    case 11:
                        e_1_1 = _c.sent();
                        e_1 = { error: e_1_1 };
                        return [3 /*break*/, 13];
                    case 12:
                        try {
                            if (collections_1_1 && !collections_1_1.done && (_a = collections_1.return)) _a.call(collections_1);
                        }
                        finally { if (e_1) throw e_1.error; }
                        return [7 /*endfinally*/];
                    case 13: return [2 /*return*/, {
                            types: types
                        }];
                }
            });
        });
    };
    return DocumentConnector;
}());
exports.DocumentConnector = DocumentConnector;
//# sourceMappingURL=documentConnector.js.map