import { DocumentConnector, DataIterator, SamplingStrategy } from "../documentConnector";
import { DatabaseType } from "prisma-datamodel";
import { DocumentIntrospectionResult } from "../documentIntrospectionResult";
import { MongoClient, Collection, Cursor } from 'mongodb';
import { Data } from '../data';
declare class MongoCursorIterator implements DataIterator {
    private cursor;
    constructor(cursor: Cursor<Data>);
    hasNext(): Promise<boolean>;
    next(): Promise<Data>;
}
export declare class MongoConnector extends DocumentConnector<Collection<Data>> {
    private client;
    constructor(client: MongoClient, samplingStrategy?: SamplingStrategy);
    getDatabaseType(): DatabaseType;
    listSchemas(): Promise<string[]>;
    protected getInternalCollections(schemaName: string): Promise<{
        name: string;
        collection: Collection<Data>;
    }[]>;
    sampleOne(collection: Collection): Promise<MongoCursorIterator>;
    sampleMany(collection: Collection, limit: number): Promise<MongoCursorIterator>;
    /**
    * Gets n random numbers chich sum up to sum.
    */
    private generateSamples;
    sampleAll(collection: Collection): Promise<MongoCursorIterator>;
    introspect(schema: string): Promise<DocumentIntrospectionResult>;
    exists(collection: Collection, id: any): Promise<boolean>;
}
export {};
